//  ===================================================================
//
//  Library:   commonlib
//  Module:    3dvector.cpp
//  Language:  C++
//  Date:      June 2004
//  Version:   1.0.0
//
//  Copyright (c) 2004
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ==================================================================

#include "3dvector.h"


namespace common {


// -------------------------------------------------------------------
// Method: normalize()
// 
// Normalizes a 3D vector.
//
// -------------------------------------------------------------------
t3DVector&
t3DVector::normalize() {
  double invNorm = INVERSE(length());
  m_x *= invNorm;
  m_y *= invNorm;
  m_z *= invNorm;

  return *this;
}

// -------------------------------------------------------------------
// Method: cross()
// 
// Computes the cross product of this vector and a given 3D vector.
//
// -------------------------------------------------------------------
t3DVector
t3DVector::cross(const t3DVector& vect) const {
  return t3DVector (
	m_y * vect.m_z - m_z * vect.m_y,
	m_z * vect.m_x - m_x * vect.m_z,
	m_x * vect.m_y - m_y * vect.m_x
  );
}


}   // end of namespace common
