//  ===================================================================
//
//  Program:  commonlib 
//  Module:   ludcmp.h
//  Language: C++
//  Date:     July 2004
//  Version:  1.0.0
//
//  Copyright (c) 2004
//
//  Marcelo Siqueira
//
//  Graduate Student
//  Department of Computer and Information Science
//  Moore School Building
//  200 South 33rd Street, Suite #62
//  Philadelphia, PA 19104-6389
//  Phone No.: (215) 898-5879
//
//  marcelos@seas.upenn.edu
//
// This program  is distributed  WITHOUT ANY WARRANTY,  and it  may be
// freely redistributed under the condition that the copyright notices
// are  not  removed,  and  no  compensation  is  received.   Private,
// research, and institutional use  is free. Distribution of this code
// as  part of  a  commercial  system is  permissible  ONLY BY  DIRECT
// ARRANGEMENT WITH THE AUTHOR.
//
//  ===================================================================

#ifndef __ludcmp_h
#define __ludcmp_h

#include "exceptionobj.h"
#include "3dvector.h"

#include <vector>


namespace common {


  // -----------------------------------------------------------------
  // class tLUdcmp
  // -------------

  class tLUdcmp {
  public:
    // constructors
    tLUdcmp(double**, unsigned);
    tLUdcmp(const tLUdcmp&);

    // destructor
    ~tLUdcmp();

    // other methods
    void solve(double*, unsigned) const;
    

  private:
    //
    // private methods
    //
    double** allocate(unsigned);
    void deallocate(double**, unsigned);
    void decomp() throw (tExceptionObject);

    //
    // private attributes
    //
    double** m_matA;
    unsigned m_nele;
    std::vector<unsigned> m_perm;
    int m_sign;
  };


}       // end of namespace common


#endif   // __ludcmp_h
